INCLUDE(CMakeForceCompiler)

IF(NOT CMAKE_TOOLCHAIN_FILE)
	MESSAGE(FATAL_ERROR "CMAKE_TOOLCHAIN_FILE not defined")
ENDIF()

SET(CAT_DIR "vc140amd64")  # only for pc tools

SET(CMAKE_EXECUTABLE_SUFFIX "$CACHE{CMAKE_EXECUTABLE_SUFFIX}")

IF(${CMAKE_BUILD_TYPE} MATCHES "Release")
	SET(CAFE_BUILD_TYPE "NDEBUG")
ELSE()
	SET(CAFE_BUILD_TYPE "DEBUG")
ENDIF()

GET_FILENAME_COMPONENT(
	tmp
	"${NLIB_RELEASE_ROOT}/system/lib/ghs/cafe/${CAFE_BUILD_TYPE}"
	ABSOLUTE)
nlib_cygwin_getwinpath(${tmp} NLIB_DIR)
MESSAGE(STATUS "CAFE_BUILD_TYPE=${CAFE_BUILD_TYPE}")

SET_PROPERTY(DIRECTORY APPEND PROPERTY COMPILE_DEFINITIONS "$<$<CONFIG:Debug>:DEBUG;_DEBUG>")
SET_PROPERTY(DIRECTORY APPEND PROPERTY COMPILE_DEFINITIONS "$<$<CONFIG:Release>:>")
SET_PROPERTY(DIRECTORY APPEND PROPERTY COMPILE_DEFINITIONS "NLIB_HAS_ZLIB")

MACRO(library_default_build_rule target)
	ADD_LIBRARY(${target} STATIC ${LIB_SRC} ${LIB_HEADER})
	SET_PROPERTY(TARGET ${target} APPEND PROPERTY INTERFACE_INCLUDE_DIRECTORIES "$<BUILD_INTERFACE:${NLIB_PKGROOT_DIR}/include>")
	TARGET_INCLUDE_DIRECTORIES(${target} BEFORE PRIVATE "${NLIB_PKGROOT_DIR}/include" "${NLIB_PKGROOT_DIR}/sources")
	INSTALL(TARGETS ${target} DESTINATION system/lib/ghs/cafe/${CAFE_BUILD_TYPE})
	INSTALL(DIRECTORY ${NLIB_PKGROOT_DIR}/include DESTINATION .)
ENDMACRO()

# sdkpad -> -lsdkpad -> ${sdklibdir}/pad.a --> linker
MACRO(target_link_libraries_default target)
	TARGET_LINK_LIBRARIES(${target} 
		sdkpad
		sdkgfd sdkmtx sdkdemo sdkgx2ut sdknn_util sdknn_crypto sdknsyshid sdknlibcurl
		sdknsysnet sdknsysccr sdknsysuvd sdkgx2 sdkavm sdktcl sdktve sdkdc sdksnd_core
		sdksnd_user sdkuvc sdkuvd sdkcamera sdkh264 sdkdmae sdknn_acp sdknn_save sdkvpad
		sdkvpadbase sdkproc_ui sdknn_ac sdkpadscore sdkcoredyn sdkzlib125)
ENDMACRO()
