﻿
/*---------------------------------------------------------------------------*

  Project: CrossRoad
  Copyright (C)2012-2016 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

 *---------------------------------------------------------------------------*/

#pragma once
#ifndef INCLUDE_NN_NLIB_BASE64INPUTSTREAM_H_
#define INCLUDE_NN_NLIB_BASE64INPUTSTREAM_H_

#include "nn/nlib/InputStream.h"
#include "nn/nlib/InputConverterStream.h"
#include "nn/nlib/Base64.h"

NLIB_NAMESPACE_BEGIN
class NLIB_VIS_PUBLIC Base64InputStream NLIB_FINAL : public InputConverterStream {
 public:
    typedef Base64Decoder::CharOption CharOption;
    Base64InputStream() NLIB_NOEXCEPT : prv_(NULL) {}
    errno_t Init(CharOption char_option) NLIB_NOEXCEPT;
    errno_t Init() NLIB_NOEXCEPT {
        return Init(Base64Decoder::BASE64_DEFAULT);
    }
    virtual ~Base64InputStream() NLIB_NOEXCEPT NLIB_OVERRIDE;

 private:
    struct Base64InputStreamPrivate;
    Base64InputStreamPrivate* prv_;
    NLIB_DISALLOW_COPY_AND_ASSIGN(Base64InputStream);
};
NLIB_NAMESPACE_END

#endif  // INCLUDE_NN_NLIB_BASE64INPUTSTREAM_H_
