﻿
/*---------------------------------------------------------------------------*

  Project: CrossRoad
  Copyright (C)2012-2016 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

 *---------------------------------------------------------------------------*/

#pragma once
#ifndef INCLUDE_NN_NLIB_CONSOLEOUTPUTSTREAM_H_
#define INCLUDE_NN_NLIB_CONSOLEOUTPUTSTREAM_H_

#include "nn/nlib/OutputStream.h"

NLIB_NAMESPACE_BEGIN

class NLIB_VIS_PUBLIC ConsoleOutputStream NLIB_FINAL : public OutputStream {
    static const size_t kBufSize = 512;
    char cos_buf_[kBufSize + 1];

 public:
    ConsoleOutputStream() NLIB_NOEXCEPT;
    virtual ~ConsoleOutputStream() NLIB_NOEXCEPT NLIB_OVERRIDE {
        bool result = this->Close();
        NLIB_UNUSED(result);
    }

 private:
    virtual bool PushBuffer_(const void* p, size_t nbytes,
                             bool do_flush) NLIB_NOEXCEPT NLIB_OVERRIDE;
    virtual bool Close_() NLIB_NOEXCEPT NLIB_OVERRIDE { return this->Flush(); }
};

NLIB_NAMESPACE_END

#endif  // INCLUDE_NN_NLIB_CONSOLEOUTPUTSTREAM_H_
