﻿
/*---------------------------------------------------------------------------*

  Project: CrossRoad
  Copyright (C)2012-2016 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

 *---------------------------------------------------------------------------*/

#pragma once
#ifndef INCLUDE_NN_NLIB_NATIVEPATHMAPPER_H_
#define INCLUDE_NN_NLIB_NATIVEPATHMAPPER_H_

#include "nn/nlib/Config.h"

NLIB_NAMESPACE_BEGIN

class NLIB_VIS_PUBLIC NativePathMapper {
 public:
    NativePathMapper() NLIB_NOEXCEPT : prv_(NULL) {}
    ~NativePathMapper() NLIB_NOEXCEPT;
    errno_t AddMap(const char* native_prefix,
                   const char* uri_prefix) NLIB_NOEXCEPT;
    errno_t ResolvePath(
        size_t* count,
        char* native,
        size_t n,
        const char* uri_path) const NLIB_NOEXCEPT;
    template <size_t N>
    errno_t ResolvePath(
        size_t* count,
        char (&native)[N],
        const char* uri_path) const NLIB_NOEXCEPT {
        return ResolvePath(count, native, N, uri_path);
    }

 private:
    struct NativePathMapperPrivate;
    NativePathMapperPrivate* prv_;
    NLIB_DISALLOW_COPY_AND_ASSIGN(NativePathMapper);
};

NLIB_NAMESPACE_END

#endif  // INCLUDE_NN_NLIB_NATIVEPATHMAPPER_H_
