﻿
/*---------------------------------------------------------------------------*

  Project: CrossRoad
  Copyright (C)2012-2016 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

 *---------------------------------------------------------------------------*/

#pragma once
#ifndef INCLUDE_NN_NLIB_URITEMPLATE_H_
#define INCLUDE_NN_NLIB_URITEMPLATE_H_

#include "nn/nlib/Uri.h"

NLIB_NAMESPACE_BEGIN

class OutputStream;

// See RFC6570: https://tools.ietf.org/html/rfc6570
class NLIB_VIS_PUBLIC UriTemplate NLIB_FINAL {
 public:
    UriTemplate() NLIB_NOEXCEPT : prv_(NULL) {}
    ~UriTemplate() NLIB_NOEXCEPT;
    errno_t SetTemplate(const char* str) NLIB_NOEXCEPT;
    errno_t SetParameter(const char* param, const char* value) NLIB_NOEXCEPT;
    void ResetParameter() NLIB_NOEXCEPT;
    errno_t Resolve(size_t* written, char* str, size_t n) const NLIB_NOEXCEPT;
    template<size_t N>
    errno_t Resolve(size_t* written, char (&str)[N]) const NLIB_NOEXCEPT {
        return Resolve(written, str, N);
    }

 private:
    struct UriTemplatePrivate;
    mutable UriTemplatePrivate* prv_;
    NLIB_DISALLOW_COPY_AND_ASSIGN(UriTemplate);
};

NLIB_NAMESPACE_END

#endif  // INCLUDE_NN_NLIB_URITEMPLATE_H_
