#!/usr/bin/env bash

cd $(dirname $0)

if ! type /usr/bin/cmake > /dev/null 2>&1; then
  echo Please install cmake for cygwin.
  echo setup/setup-cygwin-tools.sh would install cmake and other tools.
  exit 1
fi

(/bin/mkdir -p nx32/Release && cd nx32/Release && cmake -DCMAKE_TOOLCHAIN_FILE=../../../cmake/toolchain-nx.cmake -DCMAKE_BUILD_TYPE=Release -DTARGET=nx32cmake ../../)
(/bin/mkdir -p nx32/Develop && cd nx32/Develop && cmake -DCMAKE_TOOLCHAIN_FILE=../../../cmake/toolchain-nx.cmake -DCMAKE_BUILD_TYPE=RelWithDebInfo -DTARGET=nx32cmake ../../)
(/bin/mkdir -p nx64/Release && cd nx64/Release && cmake -DCMAKE_TOOLCHAIN_FILE=../../../cmake/toolchain-nx.cmake -DCMAKE_BUILD_TYPE=Release -DTARGET=nx64cmake ../../)
(/bin/mkdir -p nx64/Develop && cd nx64/Develop && cmake -DCMAKE_TOOLCHAIN_FILE=../../../cmake/toolchain-nx.cmake -DCMAKE_BUILD_TYPE=RelWithDebInfo -DTARGET=nx64cmake ../../)

